## veyon 4.1.7+repack1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1.0)

PROJECT(veyon)

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE relwithdebinfo)
ENDIF()

IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0009 NEW)
	CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

INCLUDE(AddFileDependencies)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckTypeSize)
INCLUDE(GNUInstallDirs)
INCLUDE(CotireVeyon)

FIND_PACKAGE(Git)

IF(GIT_FOUND)
    EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" describe --tags
		            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
					OUTPUT_STRIP_TRAILING_WHITESPACE
					OUTPUT_VARIABLE VERSION_STRING)
	STRING(REGEX REPLACE "^v([0-9]+)\\..*" "\\1" VERSION_MAJOR "${VERSION_STRING}")
	STRING(REGEX REPLACE "^v[0-9]+\\.([0-9]+).*" "\\1" VERSION_MINOR "${VERSION_STRING}")
	STRING(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" VERSION_PATCH "${VERSION_STRING}")

	# determine build number to use in NSIS installer and resource files
	EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" describe --tags
		            COMMAND cut -d "-" -f2
					WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
					OUTPUT_STRIP_TRAILING_WHITESPACE
					OUTPUT_VARIABLE VERSION_BUILD)
	IF(NOT VERSION_BUILD GREATER 0)
	    SET(VERSION_BUILD 0)
	ENDIF()

	# Get list of all committers from git history, ordered by number of commits.
	# The CONTRIBUTORS file is used by AboutDialog. This information can be provided
	# with -DCONTRIBUTORS=/path/to/CONTRIBUTORS instead. For instance, to generate
	# this file for version 3.0.2, the command is:
	#   git shortlog -sne v3.0.2 | cut -c8-
	SET(CONTRIBUTORS "${CMAKE_BINARY_DIR}/CONTRIBUTORS")
	IF(NOT EXISTS "${CONTRIBUTORS}")
		EXECUTE_PROCESS(COMMAND "${GIT_EXECUTABLE}" shortlog -s d160d147165271516589c304cb1b8f5e48f8527d..HEAD
			            COMMAND cut -c8-
						COMMAND sort -f
						OUTPUT_FILE "${CONTRIBUTORS}"
						WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
						TIMEOUT 10)
	ENDIF()

ENDIF()

# can't retrieve version information as not building from Git repository?
IF(NOT VERSION_STRING)
    SET(VERSION_MAJOR 4)
	SET(VERSION_MINOR 1)
	SET(VERSION_PATCH 7)
	SET(VERSION_BUILD 0)
	SET(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
ELSE()
    # remove leading character from tag name
	STRING(REPLACE "v" "" VERSION_STRING "${VERSION_STRING}")
ENDIF()

# set up compiler version variable
STRING(REGEX REPLACE "\\.[0-9]$" "" COMPILER_VERSION_MAJOR_MINOR ${CMAKE_CXX_COMPILER_VERSION})


# set up basic platform variables
IF(WIN32)
    SET(VEYON_BUILD_WIN32 1)
ELSE(WIN32)
    IF(APPLE)
	    SET(VEYON_BUILD_APPLE 1)
	ELSE(APPLE)
	    SET(VEYON_BUILD_LINUX 1)
	ENDIF(APPLE)
ENDIF(WIN32)

IF(WIN64)
    SET(VEYON_BUILD_WIN64 TRUE)
ENDIF(WIN64)

# set up library and plugin path variables
IF(CMAKE_INSTALL_LIBDIR)
    SET(VEYON_LIB_DIR "${CMAKE_INSTALL_LIBDIR}/veyon" CACHE INTERNAL "Veyon library directory")
ELSE()
    SET(VEYON_LIB_DIR lib/veyon CACHE INTERNAL "Veyon library directory")
ENDIF()

SET(VEYON_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/veyon")

IF(WIN32)
    SET(VEYON_PLUGIN_DIR "plugins")
    SET(VEYON_TRANSLATIONS_DIR "translations")
ELSE()
    SET(VEYON_PLUGIN_DIR "../${VEYON_LIB_DIR}")
    SET(VEYON_TRANSLATIONS_DIR "../share/veyon/translations")
ENDIF()


SET(VEYON_CORE_INCLUDE_DIR core/include)

# find required Qt5 modules
FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Concurrent REQUIRED)
FIND_PACKAGE(Qt5Gui REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)
FIND_PACKAGE(Qt5LinguistTools REQUIRED)

# find required libraries
FIND_PACKAGE(ZLIB REQUIRED)
FIND_PACKAGE(PNG REQUIRED)
FIND_PACKAGE(JPEG REQUIRED)
FIND_PACKAGE(LZO REQUIRED)
FIND_PACKAGE(QCA REQUIRED)

# FindOpenSSL.cmake in recent versions of CMake will only find the DLLs instead
# of the import libraries if CYGWIN is not set
SET(CYGWIN TRUE)
FIND_PACKAGE(OpenSSL REQUIRED)
UNSET(CYGWIN)

# find Linux-specific packages
IF(VEYON_BUILD_LINUX)
    FIND_PACKAGE(PAM REQUIRED)
	INCLUDE(XdgInstall)
ENDIF()


### BEGIN: libvncclient configuration
CHECK_INCLUDE_FILES(endian.h LIBVNCSERVER_HAVE_ENDIAN_H)
CHECK_INCLUDE_FILES(limits.h LIBVNCSERVER_HAVE_LIMITS_H)
CHECK_INCLUDE_FILES(time.h LIBVNCSERVER_HAVE_TIME_H)
CHECK_INCLUDE_FILES(unistd.h LIBVNCSERVER_HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(ws2tcpip.h LIBVNCSERVER_HAVE_WS2TCPIP_H)
CHECK_INCLUDE_FILES(netinet/in.h LIBVNCSERVER_HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILES(sys/endian.h LIBVNCSERVER_HAVE_SYS_ENDIAN_H)
CHECK_INCLUDE_FILES(sys/socket.h LIBVNCSERVER_HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILES(sys/stat.h LIBVNCSERVER_HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/time.h LIBVNCSERVER_HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES(sys/timeb.h LIBVNCSERVER_HAVE_SYS_TIMEB_H)
CHECK_INCLUDE_FILES(sys/types.h LIBVNCSERVER_HAVE_SYS_TYPES_H)

IF(LIBVNCSERVER_HAVE_SYS_SOCKET_H)
  LIST(APPEND CMAKE_EXTRA_INCLUDE_FILES "sys/socket.h")
ENDIF()

CHECK_TYPE_SIZE("pid_t" LIBVNCSERVER_PID_T)
CHECK_TYPE_SIZE("size_t" LIBVNCSERVER_SIZE_T)
CHECK_TYPE_SIZE("socklen_t" LIBVNCSERVER_SOCKLEN_T)

SET(_RFB_RFBCONFIG_H TRUE)
SET(LIBVNCSERVER_HAVE_LIBJPEG TRUE)
SET(LIBVNCSERVER_HAVE_LZO TRUE)
SET(LIBVNCSERVER_HAVE_LIBPNG TRUE)
SET(LIBVNCSERVER_HAVE_LIBZ TRUE)
SET(LIBVNCSERVER_HAVE_LIBSSL TRUE)
SET(LIBVNCSERVER_IPv6 TRUE)

IF(VEYON_BUILD_WIN32)
    SET(LIBVNCSERVER_NEED_INADDR_T TRUE)
ENDIF()

FILE(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR}/rfb)
IF(NOT VEYON_BUILD_LINUX OR VEYON_X11VNC_EXTERNAL)
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/3rdparty/libvncserver/rfb/rfbconfig.h.cmakein ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR}/rfb/rfbconfig.h @ONLY)
ENDIF()

### END: libvncclient configuration

# configure files for Veyon
SET(VEYONCONFIG ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR}/veyonconfig.h)

SET(IN_FILES ${VEYON_CORE_INCLUDE_DIR}/veyonconfig.h nsis/veyon.nsi core/builddata.qrc server/veyon-server.rc service/veyon-service.rc master/data/veyon-master.desktop master/veyon-master.rc configurator/data/veyon-configurator.desktop configurator/data/io.veyon.veyon-configurator.policy configurator/veyon-configurator.rc ctl/veyon-ctl.rc worker/veyon-worker.rc)
FOREACH(f ${IN_FILES})
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/${f}.in ${CMAKE_BINARY_DIR}/${f} @ONLY)
ENDFOREACH(f ${IN_FILES})

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-exceptions -std=c++11 -fstack-protector-strong ${CXXFLAGS}")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fstack-protector-strong ${CFLAGS}")
IF(NOT VEYON_BUILD_WIN32)
    SET(SYS_INC SYSTEM)
ENDIF()

ADD_DEFINITIONS(-DQT_DEPRECATED_WARNINGS -DQT_DISABLE_DEPRECATED_BEFORE=0x050600 -D_FORTIFY_SOURCE=2)

SET(3rdparty_DIR ${CMAKE_SOURCE_DIR}/3rdparty)
SET(ultravnc_DIR ${3rdparty_DIR}/ultravnc)
SET(libvncserver_DIR ${3rdparty_DIR}/libvncserver)
SET(x11vnc_DIR ${3rdparty_DIR}/x11vnc)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/${VEYON_CORE_INCLUDE_DIR} ${CMAKE_BINARY_DIR}/${VEYON_CORE_INCLUDE_DIR} ${libvncserver_DIR})
INCLUDE_DIRECTORIES(${SYS_INC} ${ZLIB_INCLUDE_DIR} ${JPEG_INCLUDE_DIR} ${PNG_INCLUDE_DIR} ${QCA_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${LZO_INCLUDE_DIR})

LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/core)

SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VEYON_LIB_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# make sub-directories
ADD_SUBDIRECTORY(core)
ADD_SUBDIRECTORY(server)
ADD_SUBDIRECTORY(service)
ADD_SUBDIRECTORY(master)
ADD_SUBDIRECTORY(configurator)
ADD_SUBDIRECTORY(ctl)
ADD_SUBDIRECTORY(worker)
ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(translations)

#
# add target for generating Windows installer
#

IF(WIN32)
	SET(TMP "veyon-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_BUILD}")

	SET(DLLDIR "${MINGW_PREFIX}/bin")
	SET(DLLDIR_LIB "${MINGW_PREFIX}/lib")
	SET(DLLDIR_GCC "/usr/lib/gcc/${MINGW_TARGET}/${COMPILER_VERSION_MAJOR_MINOR}-win32")
	IF(VEYON_BUILD_WIN64)
	    SET(DLL_GCC "libgcc_s_seh-1.dll")
		SET(DLL_DDENGINE "ddengine64.dll")
	ELSE()
	    SET(DLL_GCC "libgcc_s_sjlj-1.dll")
		SET(DLL_DDENGINE "ddengine.dll")
	ENDIF()

	ADD_CUSTOM_TARGET(win-nsi
		    COMMAND make
			COMMAND rm -rf ${TMP}
			COMMAND mkdir -p ${TMP}/interception
			COMMAND cp ${CMAKE_SOURCE_DIR}/3rdparty/interception/* ${TMP}/interception
			COMMAND cp ${CMAKE_SOURCE_DIR}/3rdparty/ddengine/${DLL_DDENGINE} ${TMP}
			COMMAND cp core/veyon-core.dll server/veyon-server.exe service/veyon-service.exe plugins/vncserver/ultravnc-builtin/vnchooks/vnchooks.dll master/veyon-master.exe configurator/veyon-configurator.exe ctl/veyon-ctl.exe worker/veyon-worker.exe ${TMP}
			COMMAND mkdir -p ${TMP}/plugins
			COMMAND cp plugins/*/*.dll ${TMP}/plugins/
			COMMAND cp plugins/*/*/*.dll ${TMP}/plugins/
			COMMAND mkdir -p ${TMP}/translations
			COMMAND cp translations/*qm ${TMP}/translations/
			COMMAND cp ${DLLDIR}/libjpeg-62.dll ${TMP}
			COMMAND cp ${DLLDIR}/libpng16-16.dll ${TMP}
			COMMAND cp ${DLLDIR}/libcrypto-1_1*.dll ${DLLDIR}/libssl-1_1*.dll ${TMP}
			COMMAND cp ${DLLDIR}/libqca-qt5.dll ${TMP}
			COMMAND cp ${DLLDIR}/libsasl2-3.dll ${TMP}
			COMMAND cp ${DLLDIR}/libldap.dll ${DLLDIR}/liblber.dll ${TMP}
			COMMAND cp ${DLLDIR}/interception.dll ${TMP}
			COMMAND cp ${DLLDIR}/liblzo2-2.dll ${TMP}
			COMMAND cp ${DLLDIR_LIB}/zlib1.dll ${TMP}
			COMMAND cp ${DLLDIR_LIB}/libwinpthread-1.dll ${TMP}
			COMMAND cp ${DLLDIR_GCC}/libstdc++-6.dll ${TMP}
			COMMAND cp ${DLLDIR_GCC}/libssp-0.dll ${TMP}
			COMMAND cp ${DLLDIR_GCC}/${DLL_GCC} ${TMP}
			COMMAND mkdir -p ${TMP}/crypto
			COMMAND cp ${DLLDIR_LIB}/qca-qt5/crypto/libqca-ossl.dll ${TMP}/crypto
			COMMAND cp ${DLLDIR}/Qt5Core.dll ${DLLDIR}/Qt5Gui.dll ${DLLDIR}/Qt5Widgets.dll ${DLLDIR}/Qt5Network.dll ${TMP}
			COMMAND mkdir -p ${TMP}/platforms
			COMMAND cp ${DLLDIR_LIB}/qt5/plugins/platforms/qwindows.dll ${TMP}/platforms
			COMMAND ${STRIP} ${TMP}/*.dll ${TMP}/*.exe ${TMP}/plugins/*.dll ${TMP}/platforms/*.dll ${TMP}/crypto/*.dll
			COMMAND cp ${CMAKE_SOURCE_DIR}/COPYING ${TMP}
			COMMAND cp ${CMAKE_SOURCE_DIR}/COPYING ${TMP}/LICENSE.TXT
			COMMAND cp ${CMAKE_SOURCE_DIR}/README.md ${TMP}/README.TXT
			COMMAND todos ${TMP}/*.txt ${TMP}/*.TXT
			COMMAND cp nsis/veyon.nsi ${TMP}
			COMMAND makensis ${TMP}/veyon.nsi
			COMMAND mv ${TMP}/veyon-*setup.exe .
			#COMMAND rm -rf ${TMP}
		)
ENDIF()

#
# package generation
#
INCLUDE(cmake/CPackDefinitions.cmake)



#
# display configuration information
#

MESSAGE("\n"
"Veyon build summary\n"
"--------------------\n"
"* Version                     : ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_BUILD} (${VERSION_STRING})\n"
"* Install prefix              : ${CMAKE_INSTALL_PREFIX}\n"
"* Library & plugin directory  : ${CMAKE_INSTALL_PREFIX}/${VEYON_LIB_DIR}\n"
"* Build type                  : ${CMAKE_BUILD_TYPE}\n"
"* Build platform              : ${CMAKE_SYSTEM_PROCESSOR}\n"
"* Compile flags               : ${CMAKE_C_FLAGS} (CXX: ${CMAKE_CXX_FLAGS})\n"
)

=== configurator/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

FILE(GLOB configurator_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB configurator_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)
FILE(GLOB configurator_UI ${CMAKE_CURRENT_SOURCE_DIR}/forms/*.ui)
SET(QRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/veyon-configurator.qrc)

QT5_WRAP_CPP(configurator_MOC_out ${configurator_INCLUDES})
QT5_WRAP_UI(configurator_UIC_out ${configurator_UI})
QT5_ADD_RESOURCES(configurator_RCC_out ${QRC_FILE})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)
ADD_EXECUTABLE(veyon-configurator ${configurator_UIC_out} ${configurator_SOURCES} ${configurator_INCLUDES} ${configurator_MOC_out} ${configurator_RCC_out})
TARGET_LINK_LIBRARIES(veyon-configurator veyon-core)

ADD_WINDOWS_RESOURCE(veyon-configurator)
MAKE_GRAPHICAL_APP(veyon-configurator)

INSTALL(TARGETS veyon-configurator RUNTIME DESTINATION bin)

IF(VEYON_BUILD_LINUX)
	XDG_INSTALL(${CMAKE_CURRENT_BINARY_DIR}/data/veyon-configurator.desktop ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-configurator.xpm ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-configurator.png ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-configurator.svg)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/data/io.veyon.veyon-configurator.policy DESTINATION ${CMAKE_INSTALL_PREFIX}/share/polkit-1/actions)
ENDIF()

COTIRE_VEYON(veyon-configurator)

=== core/CMakeLists.txt ===
FILE(GLOB veyoncore_INCLUDES
						${CMAKE_CURRENT_SOURCE_DIR}/include/*.h
						${CMAKE_CURRENT_SOURCE_DIR}/include/Configuration/*.h
)
FILE(GLOB veyoncore_SOURCES
						${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp
						${CMAKE_CURRENT_SOURCE_DIR}/src/Configuration/*.cpp
)

FILE(GLOB veyoncore_UI ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/*.ui)

# find Qt's translation directory
IF(NOT VEYON_BUILD_WIN32)
	GET_TARGET_PROPERTY(QT_QMAKE_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
	EXECUTE_PROCESS(COMMAND "${QT_QMAKE_EXECUTABLE}" -query QT_INSTALL_TRANSLATIONS
						OUTPUT_STRIP_TRAILING_WHITESPACE
						OUTPUT_VARIABLE QT_TRANSLATIONS_DIR)
	ADD_DEFINITIONS(-D'QT_TRANSLATIONS_DIR="${QT_TRANSLATIONS_DIR}"')
ENDIF()


SET(libvncclient_SOURCES
	${libvncserver_DIR}/libvncclient/cursor.c
	${libvncserver_DIR}/libvncclient/listen.c
	${libvncserver_DIR}/libvncclient/rfbproto.c
	${libvncserver_DIR}/libvncclient/sockets.c
	${libvncserver_DIR}/libvncclient/tls_none.c
	${libvncserver_DIR}/libvncclient/vncviewer.c
	${libvncserver_DIR}/common/d3des.c
	${libvncserver_DIR}/common/turbojpeg.c)


QT5_WRAP_CPP(veyoncore_MOC_out ${veyoncore_INCLUDES})
QT5_WRAP_UI(veyoncore_UIC_out ${veyoncore_UI})
QT5_ADD_RESOURCES(veyoncore_RCC_out ${CMAKE_CURRENT_SOURCE_DIR}/core.qrc ${CMAKE_CURRENT_BINARY_DIR}/builddata.qrc)

ADD_DEFINITIONS(-DBUILD_VEYON_CORE_LIBRARY)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include ${libvncserver_DIR}/common/)
ADD_LIBRARY(veyon-core SHARED ${veyoncore_SOURCES} ${veyoncore_INCLUDES} ${veyoncore_MOC_out} ${veyoncore_UIC_out} ${veyoncore_RCC_out} ${veyoncore_qt_qm_out} ${libvncclient_SOURCES})

SET_SOURCE_FILES_PROPERTIES(${libvncclient_SOURCES} PROPERTIES COMPILE_FLAGS "-Wno-unused-variable -Wno-unused-label -Wno-maybe-uninitialized -Wno-misleading-indentation -Wno-pointer-sign -Wno-int-in-bool-context")

TARGET_LINK_LIBRARIES(veyon-core
	Qt5::Concurrent
	Qt5::Gui
	Qt5::Network
	Qt5::Widgets
	${ZLIB_LIBRARIES}
	${JPEG_LIBRARIES}
	${PNG_LIBRARIES}
	${LZO_LIBRARIES}
	${QCA_LIBRARY}
	${OPENSSL_LIBRARIES}
	)

IF(VEYON_BUILD_WIN32)
	# add Windows Socket library required by libvncclient
	TARGET_LINK_LIBRARIES(veyon-core -lws2_32)
	SET_TARGET_PROPERTIES(veyon-core PROPERTIES PREFIX "")
	INSTALL(TARGETS veyon-core RUNTIME DESTINATION ${VEYON_LIB_DIR})
ELSE()
	INSTALL(TARGETS veyon-core LIBRARY DESTINATION ${VEYON_LIB_DIR})
ENDIF(VEYON_BUILD_WIN32)

COTIRE_VEYON(veyon-core)

=== ctl/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

FILE(GLOB ctl_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB ctl_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)

QT5_WRAP_CPP(ctl_MOC_out ${ctl_INCLUDES})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)
ADD_EXECUTABLE(veyon-ctl ${ctl_UIC_out} ${ctl_SOURCES} ${ctl_INCLUDES} ${ctl_MOC_out})
TARGET_LINK_LIBRARIES(veyon-ctl veyon-core Qt5::Network)

ADD_WINDOWS_RESOURCE(veyon-ctl ${CMAKE_CURRENT_BINARY_DIR}/veyon-ctl.rc)
MAKE_CONSOLE_APP(veyon-ctl)

INSTALL(TARGETS veyon-ctl RUNTIME DESTINATION bin)

=== master/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

FILE(GLOB master_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB master_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)
FILE(GLOB master_UI ${CMAKE_CURRENT_SOURCE_DIR}/forms/*.ui)
SET(QRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/master.qrc)
QT5_WRAP_CPP(master_MOC_out ${master_INCLUDES})
QT5_WRAP_UI(master_UIC_out ${master_UI})
QT5_ADD_RESOURCES(master_RCC_out ${QRC_FILE})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)
ADD_EXECUTABLE(veyon-master ${master_UIC_out} ${master_SOURCES} ${master_INCLUDES} ${master_MOC_out} ${master_RCC_out})
TARGET_LINK_LIBRARIES(veyon-master veyon-core)

ADD_WINDOWS_RESOURCE(veyon-master)
MAKE_GRAPHICAL_APP(veyon-master)

INSTALL(TARGETS veyon-master RUNTIME DESTINATION bin)

IF(VEYON_BUILD_LINUX)
	XDG_INSTALL(${CMAKE_CURRENT_BINARY_DIR}/data/veyon-master.desktop ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.xpm ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.png ${CMAKE_CURRENT_SOURCE_DIR}/data/veyon-master.svg)
ENDIF()

COTIRE_VEYON(veyon-master)

=== server/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

FILE(GLOB server_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB server_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)
QT5_WRAP_CPP(server_MOC_out ${server_INCLUDES})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)

ADD_EXECUTABLE(veyon-server ${server_SOURCES} ${server_INCLUDES} ${server_MOC_out})
TARGET_LINK_LIBRARIES(veyon-server veyon-core)

ADD_WINDOWS_RESOURCE(veyon-server)
MAKE_GRAPHICAL_APP(veyon-server)

INSTALL(TARGETS veyon-server RUNTIME DESTINATION bin)

TARGET_LINK_LIBRARIES(veyon-server
        Qt5::Gui
        Qt5::Network
        Qt5::Widgets
	)

COTIRE_VEYON(veyon-server)

=== service/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)

ADD_EXECUTABLE(veyon-service ${CMAKE_CURRENT_SOURCE_DIR}/src/main.cpp)
TARGET_LINK_LIBRARIES(veyon-service veyon-core)

ADD_WINDOWS_RESOURCE(veyon-service)
MAKE_GRAPHICAL_APP(veyon-service)

INSTALL(TARGETS veyon-service RUNTIME DESTINATION bin)

IF(VEYON_BUILD_LINUX)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/veyon-service.service.in ${CMAKE_CURRENT_BINARY_DIR}/veyon-service.service @ONLY)
	IF(NOT SYSTEMD_SERVICE_INSTALL_DIR)
		SET(SYSTEMD_SERVICE_INSTALL_DIR /lib/systemd/system)
	ENDIF()
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/veyon-service.service DESTINATION ${SYSTEMD_SERVICE_INSTALL_DIR})
ENDIF()

=== translations/CMakeLists.txt ===
# build translation files
FILE(GLOB veyon_LOCALES ${CMAKE_CURRENT_SOURCE_DIR}/*.ts)
SET(ts_targets "")
SET(qm_targets "")
FILE(GLOB_RECURSE veyon_SOURCES ${CMAKE_SOURCE_DIR}/*.cpp ${CMAKE_SOURCE_DIR}/*.h ${CMAKE_SOURCE_DIR}/*.ui)
STRING(REGEX REPLACE "${CMAKE_SOURCE_DIR}/3rdparty[^;]+;?" "" veyon_SOURCES "${veyon_SOURCES}")

ADD_CUSTOM_TARGET(download-translations)

FOREACH(ts_file ${veyon_LOCALES})
    STRING(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" ts_target "${ts_file}")
	STRING(REPLACE ".ts" ".qm" qm_target "${ts_target}")
	SET(qm_file "${CMAKE_CURRENT_BINARY_DIR}/${qm_target}")
	ADD_CUSTOM_TARGET(${ts_target} COMMAND ${Qt5_LUPDATE_EXECUTABLE} -I${CMAKE_SOURCE_DIR}/core/include -locations none -no-obsolete ${veyon_SOURCES} -ts ${ts_file})
	# add command and target for generating/updating QM file if TS file is newer or no QM file exists yet
	ADD_CUSTOM_COMMAND(OUTPUT ${qm_file} COMMAND ${Qt5_LRELEASE_EXECUTABLE} ${ts_file} -qm ${qm_file} DEPENDS ${ts_file})
	ADD_CUSTOM_TARGET(${qm_target} ALL DEPENDS ${qm_file})

	LIST(APPEND ts_targets "${ts_target}")
	LIST(APPEND qm_targets "${qm_target}")

	INSTALL(FILES ${qm_file} DESTINATION ${VEYON_INSTALL_DATADIR}/translations)

	# add target for downloading translation file from Transifex
	STRING(REPLACE ".ts" "" _translation "${ts_target}")
	IF(NOT ${_translation} STREQUAL "veyon")
	    SET(_download_translation_target "download-${_translation}")
		ADD_CUSTOM_TARGET(${_download_translation_target} COMMAND curl --user api:$ENV{TRANSIFEX_API_TOKEN} -o ${ts_file} -X GET "https://www.transifex.com/api/2/project/veyon/resource/veyonts/translation/${_translation}/?mode=default\\&file")
		ADD_DEPENDENCIES(download-translations ${_download_translation_target})
	ENDIF()
ENDFOREACH()

ADD_CUSTOM_TARGET(update-locales)
FOREACH(_item ${ts_targets})
    ADD_DEPENDENCIES(update-locales ${_item})
ENDFOREACH(_item ${ts_targets})


# find Qt's translation files
SET(QT_TRANSLATIONS_STAMP ${CMAKE_CURRENT_BINARY_DIR}/qttranslations.stamp)
IF(NOT EXISTS "${QT_TRANSLATIONS_STAMP}")
	GET_TARGET_PROPERTY(QT_QMAKE_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
	EXECUTE_PROCESS(COMMAND "${QT_QMAKE_EXECUTABLE}" -query QT_INSTALL_TRANSLATIONS
						OUTPUT_STRIP_TRAILING_WHITESPACE
						OUTPUT_VARIABLE QT_TRANSLATIONS_DIR)
	FILE(WRITE "${QT_TRANSLATIONS_STAMP}" "1")
	IF(VEYON_BUILD_WIN32)
		FILE(GLOB QT_TRANSLATIONS "${QT_TRANSLATIONS_DIR}/qt_*.qm")
		FOREACH(QT_TRANSLATION ${QT_TRANSLATIONS})
			IF(NOT QT_TRANSLATION MATCHES "help")
				STRING(REPLACE "${QT_TRANSLATIONS_DIR}/" "" QT_TRANSLATION_FILE_NAME "${QT_TRANSLATION}")
				STRING(REPLACE "qt_" "qtbase_" QTBASE_TRANSLATION_FILE_NAME "${QT_TRANSLATION_FILE_NAME}")
				# is there qtbase-specific QM file?
				IF(EXISTS "${QT_TRANSLATIONS_DIR}/${QTBASE_TRANSLATION_FILE_NAME}")
					# then use it instead of (deprecated) QM file for all Qt modules
					FILE(COPY "${QT_TRANSLATIONS_DIR}/${QTBASE_TRANSLATION_FILE_NAME}" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
					FILE(RENAME "${CMAKE_CURRENT_BINARY_DIR}/${QTBASE_TRANSLATION_FILE_NAME}" "${CMAKE_CURRENT_BINARY_DIR}/${QT_TRANSLATION_FILE_NAME}")
				ELSE()
					FILE(COPY ${QT_TRANSLATION} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
				ENDIF()
			ENDIF()
		ENDFOREACH()
	ENDIF()
ENDIF()

=== worker/CMakeLists.txt ===
INCLUDE(WindowsBuildHelpers)

FILE(GLOB worker_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h)
FILE(GLOB worker_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp)

QT5_WRAP_CPP(worker_MOC_out ${worker_INCLUDES})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src)
ADD_EXECUTABLE(veyon-worker ${worker_UIC_out} ${worker_SOURCES} ${worker_INCLUDES} ${worker_MOC_out})
TARGET_LINK_LIBRARIES(veyon-worker veyon-core Qt5::Network)

ADD_WINDOWS_RESOURCE(veyon-worker)
MAKE_GRAPHICAL_APP(veyon-worker)

INSTALL(TARGETS veyon-worker RUNTIME DESTINATION bin)

COTIRE_VEYON(veyon-worker)

=== 3rdparty/kldap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
set(PIM_VERSION "5.9.40")

project(KLdap VERSION ${PIM_VERSION})

# ECM setup
set(KF5_VERSION "5.48.0")

find_package(ECM ${KF5_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${KLdap_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(FeatureSummary)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(ECMQtDeclareLoggingCategory)
include(ECMCoverageOption)

set(KLDAP_LIB_VERSION ${PIM_VERSION})

find_package(KF5KIO ${KF5_VERSION} CONFIG REQUIRED)
find_package(KF5I18n ${KF5_VERSION} CONFIG REQUIRED)
find_package(KF5DocTools ${KF5_VERSION} CONFIG REQUIRED)
add_definitions("-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII")
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

ecm_setup_version(PROJECT VARIABLE_PREFIX KLDAP
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kldap_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfigVersion.cmake"
                        SOVERSION 5
)

########### Find packages ###########
find_package(KF5Completion ${KF5_VERSION} CONFIG REQUIRED)
find_package(KF5WidgetsAddons ${KF5_VERSION} CONFIG REQUIRED)


find_package(Ldap)
set_package_properties(Ldap PROPERTIES
  TYPE RECOMMENDED
  PURPOSE "Needed to provide LDAP functionality in KDE"
)

find_package(Sasl2)
set_package_properties(Sasl2 PROPERTIES TYPE OPTIONAL)

if (Ldap_FOUND)
   set(LDAP_FOUND 1)
endif()

if (Sasl2_FOUND)
   set(SASL2_FOUND 1)
endif()

add_definitions("-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII")
add_definitions(-DTRANSLATION_DOMAIN=\"libkldap5\")
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

########### CMake Config Files ###########
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5Ldap")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KF5LdapConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfig.cmake"
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KF5LdapConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KF5LdapTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF5LdapTargets.cmake NAMESPACE KF5::)

install(FILES
   ${CMAKE_CURRENT_BINARY_DIR}/kldap_version.h
   DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF5}
   COMPONENT Devel
)

########### Targets ###########
add_subdirectory(src)
add_subdirectory(kioslave)
if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

install( FILES kldap.renamecategories kldap.categories DESTINATION ${KDE_INSTALL_CONFDIR} )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== plugins/authkeys/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(authkeys
	AuthKeysPlugin.cpp
	AuthKeysConfigurationPage.cpp
	AuthKeysTableModel.cpp
	AuthKeysManager.cpp
	MOCFILES
	AuthKeysPlugin.h
	AuthKeysConfigurationPage.h
	AuthKeysTableModel.h
	AuthKeysManager.h
	FORMS
	AuthKeysConfigurationPage.ui
	RESOURCES
	authkeys.qrc
	COTIRE
)

=== plugins/builtindirectory/CMakeLists.txt ===
INCLUDE(BuildPlugin)

BUILD_PLUGIN(builtindirectory
	BuiltinDirectoryPlugin.cpp
	BuiltinDirectoryConfiguration.cpp
	BuiltinDirectoryConfigurationPage.cpp
	BuiltinDirectory.cpp
	MOCFILES
	BuiltinDirectoryPlugin.h
	BuiltinDirectoryConfiguration.h
	BuiltinDirectoryConfigurationPage.h
	BuiltinDirectory.h
	RESOURCES
	builtindirectory.qrc
	FORMS
	BuiltinDirectoryConfigurationPage.ui
	COTIRE
)

=== debian/changelog ===
veyon (4.1.7+repack1-1+rb2) UNRELEASED; urgency=medium

  * update

 -- Debian Edu Packaging Team <debian-edu-pkg-team@lists.alioth.debian.org>  Fri, 22 Jan 2021 12:29:40 +0800

veyon (4.1.7+repack1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Rebase 2001_disable-CPackDefinitions-cmake.patch.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 31 Jan 2019 11:07:06 +0100

veyon (4.1.6+repack1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 1001, 1002, 1003, 1004. All applied upstream.
    + Add 1001_fix-veyon-master-manpage-again.patch. Add missing hyphen in the
      man page's application name.
  * debian/control:
    + Use secure URL in Homepage: field.
    + Drop R (veyon-service): zenity or kde-baseapps-bin. Leftover from
      iTALC packaging (was requirement of the ica wrapper script).
    + Wrap line in LONG_DESCRIPTION of veyon-service.
    + Bump Standards-Version: to 4.3.0. No changes needed.
  * debian/*:
    + Use https://github.com/veyon/veyon URL in lower case letters everywhere.
  * debian/copyright:
    + Replace iTALC occurrence in the OpenSSL GPL-2 exception by the word
      Veyon.
    + Update copyright attributions.
  * debian/rules:
    + Remove more upstream files when repacking orig tarball.
  * debian/*.lintian-overrides:
    + Drop files. The epoch-changed-but-upstream-version-did-not-go-backwards
      override was only required for previous upload.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 14 Jan 2019 10:48:20 +0100

veyon (4.1.4+repack1-1) unstable; urgency=medium

  * Upload to Debian as continuation of italc. (Closes: #887394).
  * pkexec support: Drop files. Upstream now implemented pkexec support and
    now hack-around is needed anymore for the Debian package.
  * debian/changelog:
    + Drop epoch in version as package name has changed.
  * debian/*.lintian-overrides:
    + Add epoch-changed-but-upstream-version-did-not-go-backwards overrides
      for upcoming / first veyon upload.
  * debian/patches:
    + Add 1001_fix-desktop-files.patch,
          1002_add-documentation-key-to-service-file.patch,
          1003_fix-man-page-section.patch,
          1004_improve-man-page-content.patch,
          2001_disable-CPackDefinitions-cmake.patch.
    + Drop 1005_gcc47-ftbfs.patch,
           2001_inject-buildtype-from-outside.patch.
  * debian/control:
    + Adapt to veyon. Drop Patrick Winnertz from Uploaders: list. Thanks for
      your previous work on iTalc in Debian.
    + Update Homepage: and Vcs-*: fields.
    + Use secure URLs. Packaging has been migrated to salsa.debian.org.
  * debian/compat:
    + Bump DH compat level to version 10 (as long as CDBS does not yet support
      version level 11).
  * debian/*.{install,manpages,links,docs,post*,pre*}: Adapt to Veyon.
  * debian/veyon-service.install (et al.):
    + Drop veyon-service wrapper, this was iTALC stuff.
  * debian/veyon-service.*:
    + Drop preseedable debconf configuration. What worked well with iTALC does
      not make sense with Veyon's absolutely flexible role model.
  * iTALC.conf.in / Veyon.conf.in:
    + Don't ship a config template, not needed for Veyon.
  * debian/watch: iTALC is now Veyon.
  * debian/README.setup:
    + Drop iTALC specific setup README. Does not apply to Veyon anymore.
  * debian/copyright:
    + Use secure URL for Debian copyright format reference.
    + Add comment on why we repack the orig sources.
    + Drop references to files removed while repacking.
    + Update auto-generated copyright.in file.
  * debian/rules (et al.):
    + Correctly copy icons into veyon-master bin:pkg. Provide 256x256
      veyon-master.png icon.
  * debian/man/:
    + Rename italc_auth_helper.1 to veyon-auth-helper.1 and adapt to Veyon.
  * debian/desktop/*.desktop:
    + Drop files. Not required in Veyon.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/docs:
    + Ship some documentation files.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 06 Dec 2018 16:44:21 +0100

italc (1:3.0.3+dfsg1-2) unstable; urgency=medium

  * debian/control:
    + Add B-D: qttools5-dev. (Closes: #881090).
    + Bump Standards-Version: to 4.1.1. No changes needed.
  * debian/changelog, debian/man/*.1: White-space cleanup.
  * debian/copyright:
    + Remove file that is not present in upstrean sources anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 25 Nov 2017 17:20:02 +0100

italc (1:3.0.3+dfsg1-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/patches:
    + Add README, explaining our patch naming scheme. Rename existing patches
      accordingly.
    + Update/rebase 2001_inject-buildtype-from-outside.patch.
  * debian/copyright:
    + Update copyright attributions (drop lib/include/Inject.h).
    + Update copyright attributions for debian/patches/.

  [ Gianfranco Costamagna ]
  * debian/{control,rules,libitalccore.install}:
    + Turn libitalccore into multi-arch library. (Closes: #850799).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 20 Jan 2017 10:46:10 +0100

italc (1:3.0.2.90+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attributions.
    + Update autogenerated copyright.in file.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 09 Jan 2017 13:20:52 +0100

italc (1:3.0.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 001_set-static-libdir-and-rpath-for-cmake.patch,
      003_rename-plugin-dir.patch, 030_fix-man-pages.patch,
      031_fix-spelling-errors.patch. Applied or otherwise addressed
      upstream.
  * italc-client.postinst:
    + Make sure that the key directories exist before using imc for key
      creation.
  * debian/rules:
    + Fix flawed dbgsym migration.
    + In get-orig-source, drop more files not relevant for building iTALC on
      Linux.
  * debian/copyright:


=== debian/control ===
Source: veyon
Section: x11
Priority: optional
Maintainer: Debian Edu Packaging Team <debian-edu-pkg-team@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends:
 cdbs,
 dpkg-dev (>= 1.16.1~),
 debhelper (>= 10),
 cmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
 liblzo2-dev,
 libjpeg-dev,
 libpng-dev,
 imagemagick,
 libpam0g-dev,
 libavahi-client-dev,
 libldap2-dev,
 libqca-qt5-2-dev,
 libprocps-dev,
 libssl-dev,
 libv4l-dev [linux-any],
 libvncserver-dev (>= 0.9.7),
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxss-dev,
 libxtst-dev,
 libxrandr-dev,
 libxinerama-dev,
 default-jdk | gcj-jdk | gcj,
Standards-Version: 4.3.0
Homepage: https://veyon.io/
Vcs-Git: https://salsa.debian.org/debian-edu-pkg-team/veyon.git
Vcs-Browser: https://salsa.debian.org/debian-edu-pkg-team/veyon/

Package: veyon-master
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libveyon-core (= ${binary:Version}),
 veyon-service (= ${binary:Version}),
 policykit-1,
Recommends:
 veyon-configurator,
Suggests:
 veyon-ctl,
Description: Computer Monitoring and Classroom Management Software - master
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in
 different languages and provides lots of useful features:
 .
    - see what's going on in computer labs in overview mode and take screenshots
    - remote control computers to support and help users
    - broadcast teacher's screen to students in realtime by using demo mode
      (either in fullscreen or in a window)
    - lock workstations for attracting attention to teacher
    - send text messages to students
    - powering on/off and rebooting computers remote
    - remote logoff and remote execution of arbitrary commands/scripts
    - home schooling - Veyon's network technology is not restricted to a subnet
      and therefore students at home can join lessons via VPN connections just
      by installing the Veyon service
 .
 Veyon is the continuation of iTALC.
 .
 This package contains the veyon-master software. With veyon-master a teacher
 or tutor can control other machines if they run Veyon's client service software
 (package: veyon-service).

Package: veyon-service
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 libveyon-core (= ${binary:Version}),
 x11vnc,
Description: Computer Monitoring and Classroom Management Software - client service
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in
 different languages and provides lots of useful features:
 .
    - see what's going on in computer labs in overview mode and take screenshots
    - remote control computers to support and help users
    - broadcast teacher's screen to students in realtime by using demo mode
      (either in fullscreen or in a window)
    - lock workstations for attracting attention to teacher
    - send text messages to students
    - powering on/off and rebooting computers remote
    - remote logoff and remote execution of arbitrary commands/scripts
    - home schooling - Veyon's network technology is not restricted to a subnet
      and therefore students at home can join lessons via VPN connections just
      by installing the Veyon service
 .
 Veyon is the continuation of iTALC.
 .
 This package contains Veyon's client service software which allows one to
 control a machine using the veyon-master software.

Package: veyon-configurator
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libveyon-core (=${binary:Version}),
Description: Computer Monitoring and Classroom Management Software - configurator
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in
 different languages and provides lots of useful features:
 .
    - see what's going on in computer labs in overview mode and take screenshots
    - remote control computers to support and help users
    - broadcast teacher's screen to students in realtime by using demo mode
      (either in fullscreen or in a window)
    - lock workstations for attracting attention to teacher
    - send text messages to students
    - powering on/off and rebooting computers remote
    - remote logoff and remote execution of arbitrary commands/scripts
    - home schooling - Veyon's network technology is not restricted to a subnet
      and therefore students at home can join lessons via VPN connections just
      by installing the Veyon service
 .
 Veyon is the continuation of iTALC.
 .
 This package contains a graphical configuration manager for Veyon.

Package: libveyon-core
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 veyon-plugins (= ${binary:Version}),
Multi-Arch: same
Description: Computer Monitoring and Classroom Management Software - libraries
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in
 different languages and provides lots of useful features:
 .
    - see what's going on in computer labs in overview mode and take screenshots
    - remote control computers to support and help users
    - broadcast teacher's screen to students in realtime by using demo mode
      (either in fullscreen or in a window)
    - lock workstations for attracting attention to teacher
    - send text messages to students
    - powering on/off and rebooting computers remote
    - remote logoff and remote execution of arbitrary commands/scripts
    - home schooling - Veyon's network technology is not restricted to a subnet
      and therefore students at home can join lessons via VPN connections just
      by installing the Veyon service
 .
 Veyon is the continuation of iTALC.
 .
 This package provides the core libraries needed for all Veyon components.

Package: veyon-plugins
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Multi-Arch: same
Description: Computer Monitoring and Classroom Management Software - plugins
 Veyon is a software for computer monitoring and classroom management
 supporting Windows and Linux. It enables teachers to view and control
 computer labs and interact with students. Veyon is available in
 different languages and provides lots of useful features:
 .
    - see what's going on in computer labs in overview mode and take screenshots
    - remote control computers to support and help users
    - broadcast teacher's screen to students in realtime by using demo mode
      (either in fullscreen or in a window)
    - lock workstations for attracting attention to teacher
    - send text messages to students
    - powering on/off and rebooting computers remote
    - remote logoff and remote execution of arbitrary commands/scripts
    - home schooling - Veyon's network technology is not restricted to a subnet
      and therefore students at home can join lessons via VPN connections just
      by installing the Veyon service
 .
 Veyon is the continuation of iTALC.
 .
 This package provides Veyon's plugins.

=== debian/rules ===
#!/usr/bin/make -f

NULL =

include /usr/share/dpkg/buildflags.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

common-binary-post-install-arch:: list-missing

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk

NULL  =
PKD   = $(word 2, abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE = +repack1
VER  ?= $(subst $(DTYPE),,$(UVER))

DEB_DH_INSTALL_SOURCEDIR = debian/tmp
DEB_DH_MAKESHLIBS_ARGS += -V

DEB_CMAKE_NORMAL_ARGS += -DCMAKE_SKIP_RPATH=OFF \
                         -DVEYON_X11VNC_EXTERNAL=ON \
                         $(NULL)

DEB_DH_SHLIBDEPS_ARGS_veyon-master = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_veyon-client = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_veyon-management-console = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon
DEB_DH_SHLIBDEPS_ARGS_libveyoncore = -L libVeyonCore -l debian/libveyoncore/usr/lib/*/veyon

common-install-arch::
	install -D -m 644 debian/icons/veyon-256x256.png debian/veyon-master/usr/share/icons/hicolor/256x256/apps/veyon-master.png
	install -D -m 644 core/resources/icon64.png debian/veyon-master/usr/share/icons/hicolor/64x64/apps/veyon-master.png
	install -D -m 644 core/resources/icon32.png debian/veyon-master/usr/share/icons/hicolor/32x32/apps/veyon-master.png
	install -D -m 644 core/resources/icon22.png debian/veyon-master/usr/share/icons/hicolor/22x22/apps/veyon-master.png
	install -D -m 644 core/resources/icon16.png debian/veyon-master/usr/share/icons/hicolor/16x16/apps/veyon-master.png

install/veyon-service::
	mkdir -p debian/tmp/usr/bin/
	mkdir -p debian/tmp/usr/lib/veyon/
	mkdir -p debian/tmp/etc/xdg/autostart/
	mkdir -p debian/tmp/usr/share/applications/
	mkdir -p debian/tmp/usr/share/veyon/

clean::
	rm -f config.log
	rm -f config.status

get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename  --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	    && tar -xf $(PKG)_$(VER).orig.tar.bz2 --directory $(PKG)-$(VER) --strip-components 1 \
	    || $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) \
	    && $(RM) -r -v \
	       .travis/ \
	       .travis.yml \
	       3rdparty/ddengine/ \
	       3rdparty/interception/ \
	       3rdparty/x11vnc/ \
	       3rdparty/ultravnc/ \
	       3rdparty/kldap/autotests/ \
	       3rdparty/kldap/kioslave/ \
	       3rdparty/libvncserver/client_example \
	       3rdparty/libvncserver/compat/ \
	       3rdparty/libvncserver/examples/ \
	       3rdparty/libvncserver/libvncserver/ \
	       3rdparty/libvncserver/webclients/ \
	       3rdparty/libvncserver/utils/ \
	       3rdparty/libvncserver/libvncserver.pc.cmakein \
	       cmake/build_mingw32 \
	       cmake/build_mingw64 \
	       cmake/modules/MinGWCrossCompile.cmake \
	       cmake/modules/Win32Toolchain.cmake \
	       cmake/modules/Win64Toolchain.cmake \
	       configurator/data/veyon-configurator.ico \
	       contrib/ \
	       master/data/veyon-master.ico \
	       nsis/ \
	       plugins/platform/windows/ \
	       ica/x11/common/sha1.* \
	       ica/win32/ \
	       $(NULL)
	$(RM) -v $(PKG)_$(VER).orig.tar.*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"
